/**********************************************************
Total:            RFM-DK for 1519
Version:          V1.0
Prosessor:        PIC16F1519
Author:           Meng Fanbing
Email:            cal01@hoperf.com
***********************************************************/
#include "DK-1519.h"
//#include "RFM6364.h"
#include "DK-rfm68.h"
#include "lcd.h"
#include "usart.h"
#include "Keyscan.h"
#include "RFM-mode.h"

byte 	FreqSel;			//Ƶѡ
byte  TypeID;               //ģͺ
bit  set_frame;             //config mode
byte rfm_br;                //ѡ
byte rfm_pwr;                //ѡ
word rfm_fdev;              //Ƶƫѡ
word rf_tcount = 0;         //
word rf_rcount = 0;         //ռ
byte rf_rssi_value = 0;     //źŽǿ

unsigned int systime;
unsigned int systime1;


__CONFIG(FOSC_HS & WDTE_OFF & MCLRE_OFF & BOREN_OFF & IESO_OFF & FCMEN_OFF & LVP_ON);
//__CONFIG(FOSC_HS & WDTE_OFF & MCLRE_OFF & BOREN_OFF & IESO_OFF & FCMEN_OFF & LVP_ON);

main()
{
	Port_init();
	Config_init();
	
	init_comms();
	Beep_init();
	
	timer0_init();
	
	key_init();
	RFM_modeclear();
	TypeID = 0x68;
	FreqSel = 2;
	//TypeID = 0x63;
	//FreqSel = 3;
    set_frame = 0;
    rfm_br = 24;
    rfm_pwr = 10;
    rfm_fdev = 350;
    BeepOn();
	for(systime =0;systime<400;);
    BeepOff();
    //lcd_on();
    lcd_on();
    disp_init();
    RFM_REconfig();
	while(1)
	{
        for(systime=0;systime<200;);
		Keyscan();	
		RFM_mode();
        if(set_frame)
        {
            lcd_on();
            shin_FREQ();
            for(systime=0;systime<200;);
            //shin_PWR();
            //for(systime=0;systime<300;);
            shin_BR();
            for(systime=0;systime<300;);
            shin_FDEV();
            if(key3count ==3)
            {
                set_frame = 0;
                //BeepOn();
                key3count = 0;
                RFM_REconfig();
            } 	
        } 
        else
        {
		    if((RFM_modeframe==1)&&(RFM_TXframe==0)&&(RFM_RXframe==1))
		    {
                 put_md_state();
			     RFM68_NormalTX();
			     for(systime=0;systime<200;);
		    }
		    else if((RFM_modeframe==2)&&(RFM_TXframe==1)&&(RFM_RXframe==0))
		    {
			    led_alltx();
			    put_md_state();
                clear_RX();
                disp_TXtest();
                for(systime=0;systime<200;);
			    while(1)
			    {
				    RFM68_TestTX();
                    for(systime=0;systime<100;)
				    {
                        Keyscan();
                     }
				    if(key_down)
				    	 break;
                                 
			     }
			    for(systime=0;systime<200;);
		    }

		    else if(RFM_modeframe == 0)
		    {
			    //led_alltx();
			    led_off();
			    RFM68_Sleep();
			    put_md_state();
			    RFM_modeclear();
                clear_TX();
                clear_RX();
                rf_tcount = 0;
			    systime1 = 0;
			    while(1)
			    {
				    Keyscan();
				    if(key_down)
					    break;
			    }
                for(systime=0;systime<200;);
		    }
            //else
            //    RFM_modeframe = 0;
        }          
	}	
}

void Port_init(void)
{
	OPTION_REG &= 0x7F;	

	ANSELA = 0;
	PORTA = 0;
	LATA = 0;

	ANSELB = 0x00;
	PORTB = 0;
	LATB = 0;
	WPUB = 0x0F;

	ANSELC = 0;
	PORTC = 0;
	LATC = 0;

	ANSELD = 0;
	PORTD = 0;
	LATD = 0;

	ANSELE = 0;
	PORTE = 0;
	LATE = 0;
	WPUE = 0;

	TRISA = 0x00;  		// RA0-5 output;
	TRISB = 0x3F;		// RB1-5 input;
	TRISC = 0x20;		// RC2-7 output;RC5 input
	TRISD = 0x00;       // RD1-7 output
	TRISE = 0x00;       // RE0-2 output

	//nSEL_DAT = 1;
	//nSEL_CMD = 1;
	//MOSI = 1;
	//MSCK = 0;

}
void Config_init(void)
{
	OSCCON = 0x78;		// 16M crystal;
	//OSCCON = 0x70  ;		// 8M crystal;
	WDTCON = 0;		// ;
 	INTCON = 0xC0;		//disable extern interrupt,rising interrupt;
	
	//LATA = 0x00;
	//LATD = 0x00;
	
}
void timer0_init()
{
	INTCON = 0xE0;
	OPTION_REG = 0b0011;	// prescale by 16
	TMR0CS = 0;			// select internal clock
	TMR0IE = 1;			// enable timer interrupt
	GIE = 1;			// enable global interrupts
	systime = 0;
	systime1 = 0;
}

void interrupt usart()
{
	if(RCIF)
	{
		RCIF = 0;
		usart_data[usart_count]=RCREG;
		usart_count++;
		if((usart_data[0] == 0x1D)&&(usart_data[1] == 0xD1))
		{
			usart_frame=1;
		}
		//TXREG = usart_data;
	}
	if(TMR0IF)
	{
		systime++;
		systime1++;
		TMR0IF = 0;
	}		
}


/*void Delay_mS(unsigned int x)
{
	unsigned int i,j;
	for(j = 0; j < x; j ++)
	{
		for(i = 0; i < 130; i ++)
		{	;	}
	}	
}*/