
#include "DK-1519.h"
#include "usart.h"
#include "RFM-mode.h"

unsigned char usart_count;
unsigned char usart_frame;
unsigned char usart_data[30];
unsigned char usart_state[9]={'R','F','M','6',0x20,0x20,'-','X','\n'};

void init_comms()
{
	TRISC7 = 1;
	TRISC6 = 1;
	SPBRGL = 0x19;     //16M crystal
	//SPBRGL = 0x20;   //20M crystal
	SPBRGH = 0x00;
	BAUDCON = 0x00;
	RCSTA = RCSTA|0x90;
	TXSTA = TXSTA|0x20;
	RCIE = 1;
	INTCON = 0xC0;
	TXIE=0; 
	usart_count = 0;
}

	
void putch(unsigned char byte) 
{
	/* output one byte */
	while(!TXIF)	/* set when register is empty */
		continue;
	TXREG = byte;
}

unsigned char getch()
{
	// retrieve one byte 
	while(!RCIF)	 //set when register is not empty 
		continue;
	//if(RCIF == 1)
	return RCREG;	
}
void put_md_state(void)
{
	byte i;
	byte j;
	for(i=0;i<4;i++)
	{
		putch(usart_state[i]);
	}
	/*if(FreqSel<3)
	{
		putch('4');
	}
	else
	{
		putch('3');
	}*/
	j = TypeID & 0x0F;
	switch(j)
	{
		case 3:
					putch('3');
					break;
		case 4:
					putch('4');
					break;
		case 5:
					putch('5');
					break;
		case 7:
					putch('7');
					break;
		case 8:
					putch('8');
					break;
		case 9:
					putch('9');
					break;
		default:
					break;
	}


	for(i=4;i<6;i++)
	{
		putch(usart_state[i]);
	}
	if(RFM_modeframe==0)
	{
		putch('S');
		putch('L');
		putch('e');
		putch('e');
		putch('p');
		putch('\n');
	}
	/*else if(RFM_modeframe==1)
	{
		putch('N');
		putch(usart_state[6]);
		putch(usart_state[6]);
		putch('R');
		putch(usart_state[7]);
		putch(usart_state[8]);
	}*/
	//else if(RFM_modeframe==2)
    else if(RFM_modeframe==1)
	{
		putch('N');
		putch(usart_state[6]);
		putch(usart_state[6]);
		putch('T');
		putch(usart_state[7]);
		putch(usart_state[8]);
	}

	/*else if(RFM_modeframe==3)
	{
		putch('T');
		putch(usart_state[6]);
		putch(usart_state[6]);
		putch('R');
		putch(usart_state[7]);
		putch(usart_state[8]);
	}*/
	//else if(RFM_modeframe==4)
    else if(RFM_modeframe==2)
	{
		putch('T');
		putch(usart_state[6]);
		putch(usart_state[6]);
		putch('T');
		putch(usart_state[7]);
		putch(usart_state[8]);
	}
}
void get_uart(void)
{
	if(usart_frame == 1)
	{
		usart_frame = 0;
		usart_count = 0;
		//FreqSel = usart_data[2];
		putch(usart_data[0]);
		putch(usart_data[1]);
		putch(usart_data[2]);
	}
}
		
